<?php
	
	class onInfoCronInfo extends cmsAction {
		
		public function run(){
			
			/* Получаем все типы контента */
			$ctypes = $this->model_content->getContentTypes();
			
			/* За сколько дней до окончания публикации предупреждать.*/
			$days = $this->options['days'];
			
			/* Номера пользователей, которым не отправляются уведомления */
			$nosend = !empty($this->options['nosend']) ? explode(',', str_replace(' ',  '', $this->options['nosend'])) : array();
			
			/* Перебираем типы контента */
			foreach ($ctypes as $ct){
				
				/* Если в типе контента включено управление окончанием публикации */
				if (!empty($ct['is_date_range'])){
					
					/* Получаем единицы этого типа контента у которых заканчивается срок публикации*/
					$items = $this->model->filterEqual('is_pub', 1)->
					filterIsNull('is_deleted')->
					filterNotNull('date_pub_end')->
					filter('i.date_pub_end <= DATE_ADD(NOW(), INTERVAL '.$this->options['days'].' DAY)')->
					get($this->model->table_prefix.$ct['name']);
					
					/* Перебираем единицы контента */ 
					if (!empty($items)){
						foreach ($items as $item){
							/* Если есть номер автора и он не в списке неоповещаемых - рассылаем уведомления и письма */
							if (!empty($item['user_id']) && !in_array($item['user_id'], $nosend)){
								
								/* Получаем контроллер мессенджера */
								$messenger = cmsCore::getController('messages');
								
								/* Добавляем получателя - автора контента */
								$messenger->addRecipient($item['user_id']);
								
								if(!empty($this->options['notice'])){
									/* Содержимое уведомления на сайте */
									$notice = array(
									'content' => sprintf(LANG_INFO_SHOW, string_date_age($item['date_pub_end'], array('d', 'h', 'i')),
									'<a style="color:blue" href="'. href_to($ct['name'], $item['slug'].'.html') .'">' . $item['title'].'</a>'),
									'options' => array(
									'is_closeable' => true),					  
									'actions' => array(
									'view' => array(
									'title' => LANG_SHOW,
									'href' => href_to($ct['name'], $item['slug'].'.html'),
									),
									'close' => array(
									'title' => LANG_INFO_STOP
									),));
									
									/* Отправляем уведомление на сайте */
									$messenger->sendNoticePM($notice);
								}
								
								if(!empty($this->options['email'])){
									/* Отправляем письмо на почту */
									$messenger->sendNoticeEmail('date_pub_end', array(
									'nickname'		  => $this->model_users->getUser($item['user_id'])['nickname'],
									'page_url'        => href_to_abs($ct['name'], $item['slug'].'.html') ,
									'page_title'      => $item['title'],
									'date_pub_end_time' => string_date_age($item['date_pub_end'], array('d', 'h', 'i'))
									));
								}
								unset ($messenger);
							}
						}
						
					}
				}
			}
			
			
			
			
			}
			
		}
		